/****************************************************************************************//**
* \file				i2cDriver.h
*
* \brief This unit is the includes for a simple driver library for I2C bus based 
			on the Open-Core I2C-master.
* 
* \author PYD : 12/6/2013
* \version 0.1
* \date 12/6/2013

* PYD : 12/6/2013 initial version
* PYD : 12/6/2015 add a second bus for PCIe40
*//******************************************************************************************/
//                  USER ORIENTED PROCEDURES FOR EXTERNAL USE
int i2c_init(int dev, int bus, unsigned inCLK, unsigned SCLfreq);
void i2c_getInit(int dev, int bus, unsigned *inCLK, unsigned *SCLfreq);
int i2c_readMem(int dev, int bus, unsigned slaveAdd, unsigned regIndex, unsigned *val);
int i2c_writeMem(int dev, int bus, unsigned slaveAdd, unsigned regIndex, unsigned *val);
int i2c_multReadMem(int dev, int bus, unsigned slaveAdd, unsigned regIndex, int nb, unsigned **data);
